﻿Option Strict On
'  Because Option strict, we cannot use late binding, 
'1) thus we need To use Sub objects such As Geometry And Load rather than objOpenSTAAD.****
'2) Function calls need to be cast to the expected return type, e.g. myBeamCount = CInt(mySTAADGeometry.GetMemberCount)

' because of the difference between vba/vb6 and VB.NET the following changes are necessary:-
' 1) LONG become INTEGER
' 2) Functions that expect arrays need to have these cast as OBJETCS and the results cast back to the original array type.
'   This is done below using locally defined temp variable e.g. tempBeams

Public Class Form1
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        On Error GoTo ErrorHandler

        'Get the application object
        Dim myStaadObj As OpenSTAADUI.OpenSTAAD
        myStaadObj = CType(GetObject(, "StaadPro.OpenSTAAD"), OpenSTAADUI.OpenSTAAD)



        Dim mySTAADGeometry As OpenSTAADUI.OSGeometryUI
        mySTAADGeometry = CType(myStaadObj.Geometry, OpenSTAADUI.OSGeometryUI)

        Dim mySTAADLoad As OpenSTAADUI.OSLoadUI
        mySTAADLoad = CType(myStaadObj.Load, OpenSTAADUI.OSLoadUI)

        Dim strFileName As String = "*.std"
        Dim bIncludePath As Boolean = True
        Dim tempFile As Object = CObj(strFileName)
        myStaadObj.GetSTAADFile(tempFile, bIncludePath)
        strFileName = CType(tempFile, String)

        If strFileName = "" Then
            MsgBox("This app requires STAAD.Pro to have a model open")
            Exit Sub
        End If

        txtFilename.Text = strFileName

        ' Get BeamLIST
        Dim myBeamCount As Integer
        myBeamCount = CInt(mySTAADGeometry.GetMemberCount)

        Dim myBeams() As Integer
        ' This array is 0 indexed, hence only needs to be resized to count-1
        ReDim myBeams(myBeamCount - 1)

        'local temp variable
        Dim tempBeams As Object
        tempBeams = CObj(myBeams)

        mySTAADGeometry.GetBeamList(tempBeams)

        ' Cast temp variable back to the original type
        myBeams = CType(tempBeams, Integer())

        ' Get Number of load cases
        Dim myLoadCasesCount As Integer
        myLoadCasesCount = CInt(mySTAADLoad.GetPrimaryLoadCaseCount)

        ' Get Primary Load Case Numbers
        Dim myLoadCaseList() As Integer
        ReDim myLoadCaseList(myLoadCasesCount - 1)

        Dim tempLoadCase As Object
        tempLoadCase = CObj(myLoadCaseList)

        mySTAADLoad.GetPrimaryLoadCaseNumbers(tempLoadCase)
        myLoadCaseList = CType(tempLoadCase, Integer())


        'Update Dialog
        tbBeams.Text = CType(myBeamCount, String)
        tbLoadCase.Text = CType(myLoadCasesCount, String)

        For Each item As Integer In myBeams
            lbBeams.Items.Add(item)
        Next

        For Each item As Integer In myLoadCaseList
            lbLoadCase.Items.Add(item)
        Next

        myStaadObj = Nothing

        Exit Sub

ErrorHandler:
        MsgBox("This app uses OpenSTAAD and requires that STAAD.Pro is open and a model open")

    End Sub
End Class
